# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: getsta.tcl,v 1.10 1998/10/13 20:26:31 dglo Exp $

# getsta
#
# This is  a widget to allow the user to select stations
# using the MSL command
#
# Arguments:
#
#    numsta		number to append to station name and id number
#

proc getsta {{numsta 0}} {
	global messfont
#
#	Popup a top level widget for selecting stations.
#
	catch {destroy .getsta}
	toplevel .getsta
	wm title .getsta "Select Station"
	wm iconname .getsta "Stations"
	wm minsize .getsta 1 1
	placepopup .getsta
	message .getsta.msg -text "Select Station" -width 300 -font $messfont
#
#	Setup some global variables and initalize things.
#
	global station
	global location
	global type
	set stid " "
	set match " "
	set latbound " "
	set lonbound " "
	set country " "
#
#	Create buttons for selecting stations.
#
	frame .getsta.station
	button .getsta.station.state -text "Select by State" -width 20 \
		-command {
			set stype "stid"
			set match " "
			set latbound " "
			set lonbound " "
			set country "US"
			getstate
		}
	button .getsta.station.country -text "Select by Country" -width 20 \
		-command listcountry
	button .getsta.station.latlon -text "Select by Lat/Lon" -width 20\
		-command latlon

	pack append	.getsta.station	\
			.getsta.station.state		{top}	\
			.getsta.station.country		{top}	\
			.getsta.station.latlon		{top}

	frame .getsta.entries
	entry .getsta.entries.entry -textvariable station -width 10 \
		-relief sunken -state disabled

	pack append	.getsta.entries	\
			.getsta.entries.entry	{top}

	frame .getsta.info
	button .getsta.info.button -text "Show Station Info" -width 20\
		-command stainfo

	pack append	.getsta.info	\
			.getsta.info.button	{top}
#
#	More buttons.
#
	frame .getsta.buttons
	button .getsta.buttons.ok -text OK -width 20\
		-command "if {$numsta == 0} {setit}
			if {$numsta == 1} {set1}
			if {$numsta == 2} {set2}
			destroy .getsta"

	button .getsta.buttons.dismiss -text Dismiss -command "destroy .getsta"\
		-width 20

	pack append .getsta.buttons \
		.getsta.buttons.ok	{left}	\
		.getsta.buttons.dismiss	{right}

	pack append .getsta  \
		.getsta.msg		{top fill} \
		.getsta.station		{top fill pady 5m} \
		.getsta.entries		{top fill pady 5m} \
		.getsta.info		{top fill pady 5m} \
		.getsta.buttons		{bottom fill}
}

proc setit {} {

    global location
    global station
    set location $station
}
proc set1 {} {
     global stationid1
     global station1
     global stationid
     global station
     set stationid1 $stationid
     set station1 $station
}
proc set2 {} {
     global stationid2
     global station2
     global stationid
     global station
     set stationid2 $stationid
     set station2 $station
}
#*******************
#	States
# Select station by State   - this is no longer used, I'm leaving it here
# just in case....
#*******************
proc states {{w .states}} {
    catch {destroy $w}
    toplevel $w
    wm title $w "Select State"
    wm iconname $w "States"
    wm minsize $w 1 1
    placepopup $w
    global station
    global stid
    global match
    global latbound
    global lonbound
    global type
    global country
	set stid " "
	set match " "
	set latbound " "
	set lonbound " "
	set country "US"
	frame $w.state
	menubutton $w.state.menu -menu $w.state.menu.choice -text State  \
		-relief raised
	entry $w.state.entry -textvariable stid -width 3 -relief sunken
	pack append $w.state \
		$w.state.menu {left} \
		$w.state.entry {right}
	menu $w.state.menu.choice -tearoff 0
	$w.state.menu.choice add radio -label "Alabama (AL)" -variable stid \
		-value AL
	$w.state.menu.choice add radio -label "Alaska (AK)" -variable stid \
		-value AK
	$w.state.menu.choice add radio -label "Arizona (AZ)" -variable stid \
		-value AZ
	$w.state.menu.choice add radio -label "Arkansas (AR)" -variable stid \
		-value AR
	$w.state.menu.choice add radio -label "California (CA)" -variable stid \
		-value CA
	$w.state.menu.choice add radio -label "Colorado (CO)" -variable stid \
		-value CO
	$w.state.menu.choice add radio -label "Connecticut (CT)" -variable stid \
		-value CT
	$w.state.menu.choice add radio -label "Delaware (DE)" -variable stid \
		-value DE
	$w.state.menu.choice add radio -label "Florida (FL)" -variable stid \
		-value FL
	$w.state.menu.choice add radio -label "Georgia (GA)" -variable stid \
		-value GA
	$w.state.menu.choice add radio -label "Hawii (HI)" -variable stid \
		-value HI
	$w.state.menu.choice add radio -label "Idaho (ID)" -variable stid \
		-value ID
	$w.state.menu.choice add radio -label "Illinois (IL)" -variable stid \
		-value IL
	$w.state.menu.choice add radio -label "Indiana (IN)" -variable stid \
		-value IN
	$w.state.menu.choice add radio -label "Iowa (IA)" -variable stid \
		-value IA
	$w.state.menu.choice add radio -label "Kansas (KS)" -variable stid \
		-value KS
	$w.state.menu.choice add radio -label "Kentucky (KY)" -variable stid \
		-value KY
	$w.state.menu.choice add radio -label "Louisiana (LA)" -variable stid \
		-value LA
	$w.state.menu.choice add radio -label "Maine (ME)" -variable stid \
		-value ME
	$w.state.menu.choice add radio -label "Maryland (MD)" -variable stid \
		-value MD
	$w.state.menu.choice add radio -label "Massachusetts (MA)" -variable stid \
		-value MA
	$w.state.menu.choice add radio -label "Michigan (MI)" -variable stid \
		-value MI
	$w.state.menu.choice add radio -label "Minnesota (MN)" -variable stid \
		-value MN
	$w.state.menu.choice add radio -label "Mississippi (MS)" -variable stid \
		-value MS
	$w.state.menu.choice add radio -label "Missouri (MO)" -variable stid \
		-value MO
	$w.state.menu.choice add radio -label "Montana (MT)" -variable stid \
		-value MT
	$w.state.menu.choice add radio -label "Nebraska (NE)" -variable stid \
		-value NE
	$w.state.menu.choice add radio -label "Nevada (NV)" -variable stid \
		-value NV
	$w.state.menu.choice add radio -label "New Hampshire (NH)" -variable stid \
		-value NH
	$w.state.menu.choice add radio -label "New Jersey (NJ)" -variable stid \
		-value NJ
	$w.state.menu.choice add radio -label "New Mexico (NM)" -variable stid \
		-value NM
	$w.state.menu.choice add radio -label "New York (NY)" -variable stid \
		-value NY
	$w.state.menu.choice add radio -label "North Carolina (NC)" -variable stid \
		-value NC
	$w.state.menu.choice add radio -label "North Dakota (ND)" -variable stid \
		-value ND
	$w.state.menu.choice add radio -label "Ohio (OH)" -variable stid \
		-value OH
	$w.state.menu.choice add radio -label "Oklahoma (OK)" -variable stid \
		-value OK
	$w.state.menu.choice add radio -label "Oregon (OR)" -variable stid \
		-value OR
	$w.state.menu.choice add radio -label "Pennsylvania (PA)" -variable stid \
		-value PA
	$w.state.menu.choice add radio -label "Rhode Island (RI)" -variable stid \
		-value RI
	$w.state.menu.choice add radio -label "South Carolina (SC)" -variable stid \
		-value SC
	$w.state.menu.choice add radio -label "South Dakota (SD)" -variable stid \
		-value SD
	$w.state.menu.choice add radio -label "Tennessee (TN)" -variable stid \
		-value TN
	$w.state.menu.choice add radio -label "Texas (TX)" -variable stid \
		-value TX
	$w.state.menu.choice add radio -label "Utah (UT)" -variable stid \
		-value UT
	$w.state.menu.choice add radio -label "Vermont (VT)" -variable stid \
		-value VT
	$w.state.menu.choice add radio -label "Virginia (VA)" -variable stid \
		-value VA
	$w.state.menu.choice add radio -label "Washington (WA)" -variable stid \
		-value WA
	$w.state.menu.choice add radio -label "West Virgina (WV)" -variable stid \
		-value WV
	$w.state.menu.choice add radio -label "Wisconsin (WI)" -variable stid \
		-value WI
	$w.state.menu.choice add radio -label "Wyoming (WY)" -variable stid \
		-value WY

	frame $w.match
	label $w.match.label -text "Match String"
	entry $w.match.entry -textvariable match -width 20 -relief sunken
	pack append $w.match \
		$w.match.label	{left}\
		$w.match.entry	{right}

	frame $w.type
	menubutton $w.type.menu -menu $w.type.menu.choices -text "Station Type" \
		-relief raised
	entry $w.type.entry -textvariable stype -width 5 -relief sunken
	pack  append $w.type \
		$w.type.menu	{left} \
		$w.type.entry	{right}

	menu $w.type.menu.choices -tearoff 0
	$w.type.menu.choices add radio -label RADAR -variable stype  \
		-value RADAR
	$w.type.menu.choices add radio -label RAOB -variable stype  \
		-value RAOB
	$w.type.menu.choices add radio -label SURF -variable stype  \
		-value SURF
	$w.type.menu.choices add radio -label SYNOP -variable stype  \
		-value SYNOP

	frame $w.bottom
	button $w.bottom.cancel -command "destroy $w" -text  Dismiss -width 20
	button $w.bottom.ok -text OK -command "liststa; destroy $w" -width 20

	pack append $w.bottom  \
		$w.bottom.ok		{left} \
		$w.bottom.cancel	{right}

	pack append $w  \
		$w.state	{top fill} \
		$w.match	{top fill} \
		$w.bottom	{top fill}
}


proc countries {{w .country}} {
    catch {destroy $w}
    toplevel $w
    wm title $w "Select Country"
    wm iconname $w "Countries"
    wm minsize $w 1 1
    placepopup $w
    global station
    global stid
    global latbound
    global lonbound

	set stid " "
	set match " "
	set latbound " "
	set lonbound " "
	set country " "

	frame $w.country
	button $w.country.button -text "Country List"  \
		-command listcountry -relief raised
	entry $w.country.entry -textvariable country -relief sunken \
		-width 3
	pack append $w.country \
		$w.country.button	{left} \
		$w.country.entry	{right}

	frame $w.match
	label $w.match.label -text "Match String"
	entry $w.match.entry -textvariable match -width 20 -relief sunken
	pack append $w.match \
		$w.match.label	{left}\
		$w.match.entry	{right}

	frame $w.type
	menubutton $w.type.menu -menu $w.type.menu.choices -text "Station Type" \
		-relief raised
	entry $w.type.entry -textvariable stype -width 5 -relief sunken
	pack  append $w.type \
		$w.type.menu	{left} \
		$w.type.entry	{right}

	menu $w.type.menu.choices -tearoff 0
	$w.type.menu.choices add radio -label RADAR -variable stype  \
		-value RADAR
	$w.type.menu.choices add radio -label RAOB -variable stype  \
		-value RAOB
	$w.type.menu.choices add radio -label SURF -variable stype  \
		-value SURF
	$w.type.menu.choices add radio -label SYNOP -variable stype  \
		-value SYNOP

	frame $w.bottom
	button $w.bottom.cancel -command "destroy $w" -text Dismiss -width 20
	button $w.bottom.ok -command "liststa ; destroy $w" -text OK -width 20

	pack append $w.bottom  \
		$w.bottom.ok		{left}\
		$w.bottom.cancel	{right}

	pack append $w \
		$w.country	{top fill} \
		$w.match	{top fill} \
		$w.bottom	{top fill}
}



proc latlon {{w .latlon}} {
    catch {destroy $w}
    toplevel $w
    wm title $w "Lat/Lon Boundaries"
    wm iconname $w "Countries"
    wm minsize $w 1 1
    placepopup $w
    global station

	global stid country match latbound lonbound
	set stid " "
	set match " "
	set latbound " "
	set lonbound " "
	set country " "

	frame $w.latitude
	label $w.latitude.label -text "Latitude Minimum and Maximum"
	entry $w.latitude.entry -textvariable latbound -width 15 -relief sunken
	pack append $w.latitude \
		$w.latitude.label	{left} \
		$w.latitude.entry	{right}
	frame $w.longitude
	label $w.longitude.label -text "Longitude Minimum and Maximum"
	entry $w.longitude.entry -textvariable lonbound -width 15 -relief sunken
	pack append $w.longitude \
		$w.longitude.label	{left} \
		$w.longitude.entry	{right}
#
#	Bind return, tab and shift-tab.
#
	bind $w.latitude.entry <Return> "focus $w.longitude.entry"
	bind $w.longitude.entry <Return> "focus $w.latitude.entry"

	bind $w.latitude.entry <Tab> "focus $w.longitude.entry"
	bind $w.longitude.entry <Tab> "focus $w.latitude.entry"

	bind $w.latitude.entry <Shift-Tab> "focus $w.longitude.entry"
	bind $w.longitude.entry <Shift-Tab> "focus $w.latitude.entry"

#	frame $w.match
#	label $w.match.label -text "Match String"
#	entry $w.match.entry -textvariable match -width 20 -relief sunken
#	pack append $w.match \
#		$w.match.label	{left}\
#		$w.match.entry	{right}

	frame $w.type
	menubutton $w.type.menu -menu $w.type.menu.choices \
		-text "Station Type" -relief raised
	entry $w.type.entry -textvariable stype -width 5 -relief sunken
	pack  append $w.type \
		$w.type.menu	{left} \
		$w.type.entry	{right}

	menu $w.type.menu.choices -tearoff 0
	$w.type.menu.choices add radio -label RADAR -variable stype  \
		-value RADAR
	$w.type.menu.choices add radio -label RAOB -variable stype  \
		-value RAOB
	$w.type.menu.choices add radio -label SURF -variable stype  \
		-value SURF
	$w.type.menu.choices add radio -label SYNOP -variable stype  \
		-value SYNOP

	frame $w.bottom
	button $w.bottom.cancel -command "destroy $w" -text Dismiss -width 20
	button $w.bottom.ok -command "liststa;destroy $w" -text OK -width 20

	pack append $w.bottom  \
		$w.bottom.cancel	{right} \
		$w.bottom.ok		{left}

	pack append $w \
		$w.latitude	{top fill} \
		$w.longitude	{top fill} \
		$w.bottom	{top fill}
#		$w.match	{top fill} \
}

proc liststa {{w .liststa}} {
	global stid
	global match
	global latbound
	global lonbound
	global type
	global country
	global station
	global stationid
#
#	Pop up a widget listing stations.
#
	catch {destroy $w}
	toplevel $w
	wm title $w "Station Listing"
	wm iconname $w "Stations"
	wm minsize $w 1 1
	placepopup $w
	message $w.msg -font -Adobe-times-medium-r-normal--*-180* -width 700 \
		-text "Double click to select a station."
#
#	Decide what has been selected so far which determines the
#	format of the MSL command.
#
	if {$stid == "" || $stid == " "} {set state  " "
	} else {set state [format "ST=%s" $stid]}

	if {$match == "" || $match == " "} {set matchstring  " "
	} else {set matchstring [format "\"%s" $match]}

	if {$country == "" || $country == " " } {set count  " "
	} else {set count [format "CO=%s" $country]}

	if {$latbound == "" || $latbound == " "} {set latkey  " "
	} else {set latkey  [format "LAT= %s" $latbound]}

	if {$lonbound == "" || $lonbound == " "} {set lonkey  " "
	} else {set lonkey  [format "LON= %s" $lonbound]}

	if {$type == "" || $type == " "} {set stype  " "
	} else {set stype  [format "TYPE=%s" $type]}

    frame $w.frame
    scrollbar $w.frame.scroll -relief sunken -command "$w.frame.list yview"
    listbox $w.frame.list -yscroll "$w.frame.scroll set" -relief sunken \
	    -width 80 -height 10
    pack append $w.frame $w.frame.scroll {right filly} \
	    $w.frame.list {left expand fill}
	set command "MSL $count $latkey $lonkey $stype $state $matchstring"

	set msllist [open "|msl.k $count $latkey $lonkey $stype $state \{$match\} " r]
while {[gets $msllist line] > -1} {
	if {[string first DONE $line] == -1} {
	$w.frame.list insert end $line }
}
catch {close $msllist}

    bind $w.frame.list <Double-1> \
	{set stationline  [selection get]
	 set station [string range $stationline 7 11]
	 set stationid [string range $stationline 0 4]
	 destroy .liststa
    }
    button $w.dismiss -text Dismiss -command "destroy $w" -width 20

    pack append $w \
	$w.msg		{top fill} \
	$w.frame	{top} \
	$w.dismiss	{bottom}
}


proc listcountry {{w .listcountry}} {
	global country stid
#
#	Popup a widget for listing country names.
#
	catch {destroy $w}
	toplevel $w
	wm title $w "Country Listing"
	wm iconname $w "Countries"
	wm minsize $w 1 1

	placepopup $w
	message $w.msg -font -Adobe-times-medium-r-normal--*-180* -aspect 600 \
		-text "Double click to select a country."
	frame $w.frame -borderwidth 10
	scrollbar $w.frame.scroll -relief sunken -command "$w.frame.list yview"
	listbox $w.frame.list -yscroll "$w.frame.scroll set" -relief sunken \
		-width 40 -height 10 -setgrid 1
	pack append $w.frame $w.frame.scroll {right filly} \
		$w.frame.list {left expand fill}

	set first 0
	set next 39
	set ccodelist [open "|ccode.k" r]
	while {[gets $ccodelist line] > -1} {
		if { [string first DONE $line] == -1} {
			set line1 [string range $line $first 36]
			set line2 [string range $line $next 75]
			$w.frame.list insert end $line1
			$w.frame.list insert end $line2
			set first 0
			set next 39
		}
	}
#
#	Double click to select a country.
#
	bind $w.frame.list <Double-1> {
		set countryline  [selection get]
		set country [string range $countryline 0 1]
		set stid " "
		set match " "
		set latbound " "
		set lonbound " "
		liststa
		destroy .listcountry
	}
	button $w.dismiss -text Dismiss -command "destroy $w" -width 20

	pack append $w $w.msg {top fill} $w.frame {top} $w.dismiss {bottom }
}



proc stainfo {{w .liststa}} {
    catch {destroy $w}
    toplevel $w
    wm title $w "Station Info"
    wm iconname $w "Station"
    wm minsize $w 1 1
    placepopup $w
    global station


    message $w.msg -font -Adobe-times-medium-r-normal--*-180* -aspect 600 \
	    -text " Information about Station $station"
    frame $w.frame -borderwidth 10
    listbox $w.frame.list  -relief sunken \
	    -width 80 -height 2 -setgrid 1
    pack append $w.frame \
	    $w.frame.list {left expand fill}
set msllist [open "|msl.k $station " r]
while {[gets $msllist line] > -1} {
	if { [string first DONE $line] == -1} {
	$w.frame.list insert end $line }
}


    bind $w.frame.list <Double-1> \
	{set stationline  [selection get]
	 set station [string range $stationline 9 13]
	 destroy $w
    }
    button $w.dismiss -text Dismiss -command "destroy $w" -width 20

    pack append $w $w.msg {top fill} $w.frame {top}\
	$w.dismiss {bottom}
}
