# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: getstate.tcl,v 1.6 1998/10/13 20:26:32 dglo Exp $

# getstate
#
# Create a top-level window containing a listbox showing a
# state listing.
#

proc getstate {} {
    catch {destroy .states}
    toplevel .states
    wm title .states "State Listing"
    wm iconname .states "States"
    wm minsize .states 1 1
    placepopup .states
    message .states.msg -font -Adobe-times-medium-r-normal--*-180* \
	-aspect 700 -relief raised\
	    -text "Double click to select state."
    frame .states.frame -borderwidth 10
    scrollbar .states.frame.scroll -relief sunken \
	    -command ".states.frame.list yview"
    listbox .states.frame.list -yscroll ".states.frame.scroll set"\
	    -relief sunken \
	    -width 25 -height 10 -setgrid 1
    pack append .states.frame .states.frame.scroll {right filly} \
	    .states.frame.list {left expand fill}
.states.frame.list insert 0 "Alabama (AL)" "Alaska (AK)" "Arizona (AZ)"\
"Arkansas (AR)" "California (CA)" "Colorado (CO)" "Connecticut (CT)" \
"Delaware (DE)" "Florida (FL)" "Georgia (GA)" "Hawaii (HI)" "Idaho (ID)"\
"Illinois (IL)" "Indiana (IN)" "Iowa (IA)" "Kansas (KS)" "Kentucky (KY)"\
"Louisiana (LA)" "Maine (ME)" "Maryland (MD)" "Massachusetts (MA)"\
"Michigan (MI)" "Minnesota (MN)" "Mississippi (MS)" "Missouri (MO)"\
"Montana (MT)" "Nebraska (NE)" "Nevada (NV)" "New Hampshire (NH)"\
"New Jersey (NJ)" "New Mexico (NM)" "New York (NY)" "North Carolina (NC)"\
"North Dakota (ND)" "Ohio (OH)" "Oklahoma (OK)" "Oregon (OR)"\
"Pennsylvania (PA)" "Rhode Island (RI)" "South Carolina (SC)" \
"South Dakota (SD)" "Tennessee (TN)" "Texas (TX)" "Utah (UT)" "Vermont (VT)"\
"Virginia (VA)" "Washington (WA)" "West Virginia (WV)" "Wisconsin (WI)"\
"Wyoming (WY)"

catch {close $lalist}
    bind .states.frame.list <Double-1> \
	{set line [selection get]
	 set ind [string first "(" $line]
	 set state [string range $line [expr $ind +1] [expr $ind +2]]
	 global stype
	 case $stype {
		stid {set stid $state; liststa}
		umap {set umap $state}
		smap {set smap $state}
		map {set map $state}
		station {set station $state}
		default {set stateab $state}
	}

	 destroy .states
    }
    button .states.ok -text Dismiss -command "destroy .states"
pack .states.msg -side top -fill x
pack .states.frame -side top
pack .states.ok -side bottom
catch {close $lalist}
}
