# Copyright(c) 1998, Space Science and Engineering Center, UW-Madison
# Refer to "McIDAS Software Acquisition and Distribution Policies"
# in the file  mcidas/data/license.txt

# $Id: ptmore.tcl,v 1.9 1998/10/13 20:26:47 dglo Exp $

proc ptmore {} {
#

frame .frame.hi
#
# color level for contours
#

global	red
global	green
global	blue
global	widgetname
global	widgetname2
global hi


global clev
set clev 3
set widgetname ".frame.hi.plotcol.swatch"
set widgetname2 ""

frame .frame.hi.plotcol
entry .frame.hi.plotcol.entry -textvariable clev -width 7 -relief groove \
	-state disabled
button .frame.hi.plotcol.button -text "Plot Color" -relief raised \
	-command "listcol 2" -width 18

mc2rgb "$clev"

set plotcol [format "#%02x%02x%02x" $red $green $blue]
frame .frame.hi.plotcol.swatch -width 20 -height 20 -bg $plotcol

pack .frame.hi.plotcol.button -side left -padx 10
pack .frame.hi.plotcol.entry -side right -padx 10
pack .frame.hi.plotcol.swatch -side right

pack .frame.hi.plotcol -side top -pady 2 -fill both

set lsize 7
frame .frame.hi.lsize
label .frame.hi.lsize.label -text "Label Height" -width 20
entry .frame.hi.lsize.entry -textvariable lsize -width  7 -relief sunken

pack .frame.hi.lsize.label -side left -padx 10
pack .frame.hi.lsize.entry -side right -padx 10

pack .frame.hi.lsize -side top -pady 2 -fill both
#
#	Panel number
#
set panel " "
frame .frame.hi.panel
menubutton .frame.hi.panel.menu -text "Screen Panel"  -relief raised \
	-menu .frame.hi.panel.menu.choices -width 20
entry .frame.hi.panel.entry -width 7  -relief groove -textvariable panel \
	-state disabled
menu .frame.hi.panel.menu.choices -tearoff 0
.frame.hi.panel.menu.choices add radio -label "Full Screen ( )" \
	-value " " -variable panel
.frame.hi.panel.menu.choices add radio -label "Upper Left (1)" \
	-value 1 -variable panel
.frame.hi.panel.menu.choices add radio -label "Upper Right (2)" \
	-value 2 -variable panel
.frame.hi.panel.menu.choices add radio -label "Lower Left (3)" \
	-value 3 -variable panel
.frame.hi.panel.menu.choices add radio -label "Lower Right (4)" \
	-value 4 -variable panel
pack .frame.hi.panel.menu -side left -padx 10
pack .frame.hi.panel.entry -side right -padx 10

pack .frame.hi.panel -side top -pady 2 -fill both


#
#	color level for map
#
global mlev
set mlev 1

mc2rgb "$mlev"
set widgetname2 ".frame.hi.colmap.swatch"

set mapcolor [format "#%02x%02x%02x" $red $green $blue]
frame .frame.hi.colmap
button .frame.hi.colmap.button -text "Map Color" -relief raised \
	-command "listcol 1" -width  18
entry .frame.hi.colmap.entry -textvariable mlev -width 15 -relief groove \
	-state disabled -width 7


frame .frame.hi.colmap.swatch -width 20 -height 20 -bg $mapcolor

pack .frame.hi.colmap.button  -side left  -padx 10
pack .frame.hi.colmap.entry -side right -padx 10
pack .frame.hi.colmap.swatch -side right

pack .frame.hi.colmap -side top -pady 2 -fill both

#
#	Projection
#

set project "MERC"
frame .frame.hi.project
menubutton  .frame.hi.project.menu -text "Projection" -relief raised  \
	-menu .frame.hi.project.menu.choices -width 20
menu .frame.hi.project.menu.choices -tearoff 0
.frame.hi.project.menu.choices add radio -label "Conformal (CONF)" \
	-variable project -value CONF
.frame.hi.project.menu.choices add radio -label "Mercator (MERC)"  \
	-variable project -value MERC
entry .frame.hi.project.entry -textvariable project -width 7 -relief groove \
	-state disabled

pack .frame.hi.project.menu -side left -padx 10
pack .frame.hi.project.entry -side right -padx 10
pack .frame.hi.project -side top -pady 2 -fill both

#
#	Standard Latitude
#

set slat " "
frame .frame.hi.slat
label .frame.hi.slat.label -text "Standard Latitude " -width 20
entry .frame.hi.slat.entry -textvariable slat -width 7 -relief sunken


pack .frame.hi.slat.label -side left -padx 10
pack .frame.hi.slat.entry -side right -padx 10

pack .frame.hi.slat -side top -pady 2 -fill both
#
#	Standard Longitude
#

set slon " "
frame .frame.hi.slon
label .frame.hi.slon.label -text "Standard Longitude" -width 20
entry .frame.hi.slon.entry -textvariable slon -width 7  -relief sunken


pack .frame.hi.slon.label -side left -padx 10
pack .frame.hi.slon.entry -side right -padx 10
pack .frame.hi.slon -side top -pady 2 -fill both

}
